local fs = require "love.filesystem"
local json = require "lunajson"


local function jsonDecode(data)
	return json.decode(data)
end


local m = {}


m.read = function(xdeck)
	local check
	local deck = fs.read("Backup/"..xdeck)
	if not deck then return nil, "Could not read deck file : "..xdeck end
	check, deck = pcall(jsonDecode, deck)
	if check and type(deck) == "table" and type(deck.buttonData) == "table" then
		return deck
	else
		return nil, "Could not decode deck file : "..xdeck
	end
end


m.write = function(xdeck, data)
	local success, msg = fs.write("Backup/"..xdeck, json.encode(data, "___null___"))
	if not success then return false, msg end
	return true
end


m.press = function(xdeck, button)
	local deck, msg = m.read(xdeck)
	if not deck then return nil, msg end
	local bData = deck.buttonData[button] or {}
	--if type(bData) ~= "table" then return nil, "Button empty" end
	local cmd = bData.cmd
	local tgLabel, tgIconData
	if (bData.group or "") == "*" then
		local b2Data = deck.buttonData[tostring(tonumber(button) + 1000)] or {}
		if bData.active then cmd = b2Data.cmd end
		bData.active = not bData.active
		m.write(xdeck, deck)
		local icon
		if bData.active then
			tgLabel = b2Data.label
			icon = b2Data.icon
		else
			tgLabel = bData.label
			icon = bData.icon
		end
		if icon and deck.iconData and deck.iconData[icon] then
			tgIconData = "data:image/png;base64,"..deck.iconData[icon]
		else
			tgIconData = "/img/blankIcon444.png"
		end
	end
	--if type(bData) ~= "table" then return nil, "Button empty" end 
	return cmd or "", nil, tgLabel, tgIconData
end


return m