local m = {}


-- custom functions
m.fn = {}


m.math = function(exp)
	local a, b, c -- values / operators
	local i, j    -- string positions
	local v       -- substitution value
		
	-- functions
	while true do
		i, j, a, b = string.find(exp, "(%a+)%(%s*([^(]-)%s*%)")
		if not i then break end
		local args = {}
		for p in string.gmatch(b, "[^,]+") do
			args[#args + 1] = p
		end
		local s, f = nil, math[a] or m.fn[a]
		if f then
			s, v = pcall(f, unpack(args))
			if not s then v = 0 end
		else
			v = 0
		end
		exp = exp:sub(1, i - 1)..v..exp:sub(j + 1)
	end

	-- brackets	
	while true do
		i, j, a = string.find(exp, "%((.-)%)")
		if not i then break end
		v = m.math(a)
		exp = exp:sub(1, i - 1)..v..exp:sub(j + 1)
	end
	
	-- multiplication / division / modulus
	while true do
		i, j, a, b, c = string.find(exp, "(%-*[%d%.]+)%s*([%*%/%%])%s*(%-*[%d%.]+)")
		if not i then break end
		if b == "*" then
			v = a * c
		elseif b == "/" then
			v = a / c	
		elseif b == "%" then
			v = a % c	
		end
		exp = exp:sub(1, i - 1)..v..exp:sub(j + 1)
	end
	
	-- add / subtract
	while true do
		i, j, a, b, c = string.find(exp, "(%-*[%d%.]+)%s*([%+%-])%s*(%-*[%d%.]+)")
		if not i then break end
		v = (b == "+") and (a + c) or (a - c)
		exp = exp:sub(1, i - 1)..v..exp:sub(j + 1)
	end

	-- comparison
	while true do
		local i, j, a, b, c = string.find(exp, "(%-*[%d%.]+)%s*([%>%<%=]+)%s*(%-*[%d%.]+)")
		if not i then break end
		a = tonumber(a or 0)
		c = tonumber(c or 0)
		if b == "=" or b == "==" then
			v = a == c
		elseif b == "<>" then
			v = a ~= c
		elseif b == ">" then
			v = a > c
		elseif b == "<" then
			v = a < c
		elseif b == ">=" then
			v = a >= c
		elseif b == "<=" then
			v = a <= c
		else
			v = false
		end
		exp = exp:sub(1, i - 1)..(v and 1 or 0)..exp:sub(j + 1)
	end
	
	return tonumber(exp) or 0
end


return m