local fs = require "love.filesystem"
fs.setIdentity("UPDeck")


function fs.rDelete(target)
	local info = fs.getInfo(target)
	if not info then return end
	if info.type == "directory" then
		for _, item in pairs(fs.getDirectoryItems(target)) do
			fs.rDelete(target.."/"..item)
			fs.remove(target.."/"..item)
		end
	elseif info.type == "file" then
		fs.remove(target)
	end
	fs.remove(target)
end


function fs.rCopy(src, dest)
	local errors = 0
	for _, item in pairs(fs.getDirectoryItems(src)) do
		local info = fs.getInfo(src.."/"..item)
		if info.type == "directory" then
			if fs.createDirectory(dest.."/"..item) then
				fs.rCopy(src.."/"..item, dest.."/"..item)
			else
				errors = errors + 1
			end
		elseif info.type == "file" then
			local data, err = fs.read(src.."/"..item)
			if not data or not fs.write(dest.."/"..item, data) then
				errors = errors + 1
			end
		end
	end
	return errors
end


function fs.copyWinScript(script)
	local f, msg = fs.read("winscripts/"..script)
	if not f then return f, msg end
	return fs.write(script, f)
end