local platform = love.system.getOS()
local fs = love.filesystem
local kActive, kCodes


if platform == "Windows" then

	kActive = fs.getInfo("kp.vbs")

elseif platform == "OS X" then

	kActive = true
	kCodes = {
		["A"]  = 0x00,
		["S"]  = 0x01,
		["D"]  = 0x02,
		["F"]  = 0x03,
		["H"]  = 0x04,
		["G"]  = 0x05,
		["Z"]  = 0x06,
		["X"]  = 0x07,
		["C"]  = 0x08,
		["V"]  = 0x09,
		["B"]  = 0x0B,
		["Q"]  = 0x0C,
		["W"]  = 0x0D,
		["E"]  = 0x0E,
		["R"]  = 0x0F,
		["Y"]  = 0x10,
		["T"]  = 0x11,
		["1"]  = 0x12,
		["2"]  = 0x13,
		["3"]  = 0x14,
		["4"]  = 0x15,
		["6"]  = 0x16,
		["5"]  = 0x17,
		["="]  = 0x18,
		["9"]  = 0x19,
		["7"]  = 0x1A,
		["-"]  = 0x1B,
		["8"]  = 0x1C,
		["0"]  = 0x1D,
		["]"]  = 0x1E,
		["O"]  = 0x1F,
		["U"]  = 0x20,
		["["]  = 0x21,
		["I"]  = 0x22,
		["P"]  = 0x23,
		["L"]  = 0x25,
		["J"]  = 0x26,
		["'"]  = 0x27,
		["K"]  = 0x28,
		[";"]  = 0x29,
		["\\"] = 0x2A,
		[","]  = 0x2B,
		["/"]  = 0x2C,
		["N"]  = 0x2D,
		["M"]  = 0x2E,
		["."]  = 0x2F,
		["`"]  = 0x32,
		["RETURN"]        = 0x24,
		["TAB"]           = 0x30,
		["SPACE"]         = 0x31,
		["DELETE"]        = 0x33,
		["ESCAPE"]        = 0x35,
		--["COMMAND"]       = 0x37,
		--["SHIFT"]         = 0x38,
		--["CAPSLOCK"]      = 0x39,
		--["OPTION"]        = 0x3A,
		--["CONTROL"]       = 0x3B,
		--["RIGHTSHIFT"]    = 0x3C,
		--["RIGHTOPTION"]   = 0x3D,
		--["RIGHTCONTROL"]  = 0x3E,
		--["FUNCTION"]      = 0x3F,
		["F17"]           = 0x40,
		["VOLUMEUP"]      = 0x48,
		["VOLUMEDOWN"]    = 0x49,
		["MUTE"]          = 0x4A,
		["F18"]           = 0x4F,
		["F19"]           = 0x50,
		["F20"]           = 0x5A,
		["F5"]            = 0x60,
		["F6"]            = 0x61,
		["F7"]            = 0x62,
		["F3"]            = 0x63,
		["F8"]            = 0x64,
		["F9"]            = 0x65,
		["F11"]           = 0x67,
		["F13"]           = 0x69,
		["F16"]           = 0x6A,
		["F14"]           = 0x6B,
		["F10"]           = 0x6D,
		["F12"]           = 0x6F,
		["F15"]           = 0x71,
		["HELP"]          = 0x72,
		["HOME"]          = 0x73,
		["PAGEUP"]        = 0x74,
		["FORWARDDELETE"] = 0x75,
		["F4"]            = 0x76,
		["END"]           = 0x77,
		["F2"]            = 0x78,
		["PAGEDOWN"]      = 0x79,
		["F1"]            = 0x7A,
		["LEFT"]     = 0x7B,
		["RIGHT"]    = 0x7C,
		["DOWN"]     = 0x7D,
		["UP"]       = 0x7E,
	}

elseif platform == "Linux" then

	kActive = true

end


return { active = kActive, codes = kCodes }