require "love.sound"
require "love.audio"
local sources = {}


function love.audio.update()
	local remove = {}
	for _,s in pairs(sources) do
		if not s:isPlaying() then
			remove[#remove + 1] = s
		end
	end

	for i,s in ipairs(remove) do
		sources[s] = nil
	end
end


local play = love.audio.play
function love.audio.play(file, mode, loop)
	local ok, src
	if not sources[file] then
		ok, src = pcall(love.audio.newSource, file, mode or "stream")
		if not ok then
			return nil
		end
		sources[file] = src
	else
		src = sources[file]
	end
	src:setLooping(loop or false)
	play(src)
	return src
end


local stop = love.audio.stop
function love.audio.stop(file, clean)
	if not file then return nil end
	if sources[file] then
		stop(sources[file])
		if clean then sources[file] = nil end
	end
end